#include <windows.h>
#include <tlhelp32.h>
#include "crtools.h"


DWORD getPID(char* name) {
	HANDLE hp = CreateToolhelp32Snapshot (TH32CS_SNAPPROCESS, 0);
	if ( hp == INVALID_HANDLE_VALUE) return 0;
	PROCESSENTRY32 pe; 
	Process32First(hp, &pe);
	if ( strstr(pe.szExeFile, name) != 0) return pe.th32ProcessID; 
	while (Process32Next(hp, &pe)) 
		if ( strstr(pe.szExeFile, name) != 0) return pe.th32ProcessID; 
	CloseHandle(hp);
	return 0;
}


const BYTE injcode[22] = {	
//  0     1     2     3     4     5
	0x68, 0x00, 0x00, 0x00, 0x00,			// puch load library arg
	0xff, 0x15, 0x00, 0x00, 0x00, 0x00,		//call loadlibrary
	0x68, 0x00, 0x00, 0x00, 0x00,			//exitthread_arg
	0xff, 0x15, 0x00, 0x00, 0x00, 0x00		//adr_from_call_exitthread
};

const int dllnamemax = MAX_PATH;

const int loadlibrary_arg = 1;
const int adr_from_call_loadlibrary = loadlibrary_arg + 6;

const int exitthread_arg = adr_from_call_loadlibrary + 5;
const int adr_from_call_exitthread = exitthread_arg + 6;

const int addr_loadlibrary = adr_from_call_exitthread +4;
const int addr_exitthread = addr_loadlibrary +4;
const int libraryname = addr_exitthread +4;
const int injsize = addr_exitthread + dllnamemax;

void msg(const char *m) {
	MessageBox(0,m,"crtool",0);
}

bool injectDll (DWORD pid, char *lpszDllName) {
	HANDLE hProcess;
	BYTE *p_code;
	BYTE code[injsize];
	DWORD wr, id;

	hProcess=OpenProcess(PROCESS_CREATE_THREAD|PROCESS_VM_WRITE|
						 PROCESS_VM_OPERATION, FALSE, pid);
	if (hProcess == NULL) return false;
    
    p_code = (BYTE*)VirtualAllocEx(hProcess, 0, injsize,
                                   MEM_COMMIT, PAGE_EXECUTE_READWRITE);
    if (p_code==NULL) return false; 

	memcpy(code, injcode, sizeof(injcode));

    *(DWORD*)(code + loadlibrary_arg) = DWORD(p_code + libraryname);
	*(DWORD*)(code+adr_from_call_loadlibrary) =  (DWORD)(p_code + addr_loadlibrary); 
    *(DWORD*)(code + adr_from_call_exitthread) = (DWORD)(p_code + addr_exitthread);
	*(DWORD*) (code+addr_loadlibrary) = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"), "LoadLibraryA");
    *(DWORD*) (code+addr_exitthread)  = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"),"ExitThread");
	
	if(strlen(lpszDllName) > dllnamemax) return false;
	strcpy((char*)code + libraryname, lpszDllName );
 
  /*  cmds     
    :
      push  adr_library_name               ; - loadlibrary
      call dword ptr [loadlibrary_adr]     ;  LoadLibrary
      push exit_thread_arg                 ;  ExitThread
      call dword ptr [exit_thread_adr]     ; ExitThread    
  */
	WriteProcessMemory(hProcess, p_code, code, injsize, &wr);
	assert (wr == injsize);
	HANDLE z = CreateRemoteThread(hProcess, NULL, 0,
								(unsigned long (__stdcall *)(void *))p_code, 0, 0, &id);
	assert (z != 0);
	WaitForSingleObject(z, INFINITE);
	VirtualFreeEx(hProcess, (void*)p_code, injsize, MEM_RELEASE);

	return true;
};

//       - .idata  
FARPROC* findFP(FARPROC proc, char* dllname, char* moduleName){	
	BYTE *pimage = (BYTE*)GetModuleHandle(moduleName);
	assert (pimage != NULL);
	BYTE *pidata;
	IMAGE_DOS_HEADER *idh;
	IMAGE_OPTIONAL_HEADER *ioh;
	IMAGE_SECTION_HEADER *ish;
	IMAGE_IMPORT_DESCRIPTOR *iid;
	FARPROC *isd; 
	
	assert (pimage != NULL);
	idh = (IMAGE_DOS_HEADER*)pimage;
	//VirtualProtect (pimage + idh->e_lfanew+ 4 + sizeof(IMAGE_FILE_HEADER),10,PAGE_READONLY,NULL);
	ioh = (IMAGE_OPTIONAL_HEADER*)(pimage + idh->e_lfanew
                                   + 4 + sizeof(IMAGE_FILE_HEADER));
	ish = (IMAGE_SECTION_HEADER*)((BYTE*)ioh + sizeof(IMAGE_OPTIONAL_HEADER));
	
	if (idh->e_magic != 0x5A4D) msg("Not exe hdr");
	for(int i=0; i<16; i++)
		if(strcmp((char*)((ish+ i)->Name) , ".idata") == 0) break;
	if(i==16) msg("Unable to find .idata section");

	iid = (IMAGE_IMPORT_DESCRIPTOR*)(pimage + (ish +i)->VirtualAddress );
	
	
	while(iid->Name) {
		if(strcmp((char*)(pimage + iid->Name), dllname) ==0 ) break;
		iid++;
	}

	isd = (FARPROC*)(pimage + iid->FirstThunk);
	while(*isd!=proc && *isd!=0)  isd++;
	return isd;
}
	